Package org.eclipse.cdt.core.errorparsers

## Class ErrorPattern

- java.lang.Object
- - org.eclipse.cdt.core.errorparsers.ErrorPattern

    public class ErrorPattern
    extends Object

Error Pattern - used by Error Parser to convert build output to problem markers

Since:
  5.1 Clients may extend this class.

### Constructor Summary

Constructors
`ErrorPattern​(String pattern)` Pattern for errors that should be skipped.
`ErrorPattern​(String pattern, int groupDesc, int severity)` Pattern for errors not associated file a file (e.g.
`ErrorPattern​(String pattern, int groupFileName, int groupLineNum, int groupDesc, int groupVarName, int severity)` Full Pattern Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`String` `getDesc​(Matcher matcher)`
`String` `getFileName​(Matcher matcher)`
`int` `getLineNum​(Matcher matcher)`
`protected org.eclipse.core.runtime.IPath` `getLocation​(String filename)` If the file designated by filename exists, return the IPath representation of the filename If it does not exist, try cygpath translation
`Matcher` `getMatcher​(CharSequence input)`
`int` `getSeverity​(Matcher matcher)`
`String` `getVarName​(Matcher matcher)`
`boolean` `processLine​(String line, ErrorParserManager eoParser)` Parse a line of build output and register error/warning for Problems view.
`protected boolean` `recordError​(Matcher matcher, ErrorParserManager eoParser)` Register the error in `ErrorParserManager`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ErrorPattern

    public ErrorPattern​(String pattern,
                        int groupFileName,
                        int groupLineNum,
                        int groupDesc,
                        int groupVarName,
                        int severity)

Full Pattern Constructor. Note that a group equal -1 means that the parameter is missing in the error message.

Parameters:
  `pattern` - - regular expression describing the message
  `groupFileName` - - matcher group of file name
  `groupLineNum` - - matcher group of line number
  `groupDesc` - - matcher group of description
  `groupVarName` - - matcher group of variable name
  `severity` - - severity, one of
  `IMarkerGenerator.SEVERITY_INFO`,
  `IMarkerGenerator.SEVERITY_WARNING`,
  `IMarkerGenerator.SEVERITY_ERROR_RESOURCE`,
  `IMarkerGenerator.SEVERITY_ERROR_BUILD`

#### ErrorPattern

    public ErrorPattern​(String pattern,
                        int groupDesc,
                        int severity)

Pattern for errors not associated file a file (e.g. make and linker errors).

Parameters:
  `pattern` - - regular expression describing the message
  `groupDesc` - - matcher group of description
  `severity` - - severity, one of
  `IMarkerGenerator.SEVERITY_INFO`,
  `IMarkerGenerator.SEVERITY_WARNING`,
  `IMarkerGenerator.SEVERITY_ERROR_RESOURCE`,
  `IMarkerGenerator.SEVERITY_ERROR_BUILD`

#### ErrorPattern

    public ErrorPattern​(String pattern)

Pattern for errors that should be skipped.

Parameters:
  `pattern` - - error pattern.

### Method Detail

#### getMatcher

    public Matcher getMatcher​(CharSequence input)

Parameters:
  `input` - - input line.
Returns:
  matcher to interpret the input line.

#### getFileName

    public String getFileName​(Matcher matcher)

Parameters:
  `matcher` - - matcher to parse the input line.
Returns:
  parsed file name or `null`.

#### getLineNum

    public int getLineNum​(Matcher matcher)

Parameters:
  `matcher` - - matcher to parse the input line.
Returns:
  parsed line number or `0`.

#### getDesc

    public String getDesc​(Matcher matcher)

Parameters:
  `matcher` - - matcher to parse the input line.
Returns:
  parsed description or `null`.

#### getVarName

    public String getVarName​(Matcher matcher)

Parameters:
  `matcher` - - matcher to parse the input line.
Returns:
  parsed variable name or `null`.

#### getSeverity

    public int getSeverity​(Matcher matcher)

Parameters:
  `matcher` - - matcher to parse the input line.
Returns:
  severity of the problem.

#### processLine

    public boolean processLine​(String line,
                               ErrorParserManager eoParser)

Parse a line of build output and register error/warning for Problems view.

Parameters:
  `line` - - one line of output.
  `eoParser` - - `ErrorParserManager`.
Returns:
  `true` if error/warning/info problem was found.

#### recordError

    protected boolean recordError​(Matcher matcher,
                                  ErrorParserManager eoParser)

Register the error in `ErrorParserManager`.

Parameters:
  `matcher` - - matcher to parse the input line.
  `eoParser` - - `ErrorParserManager`.
Returns:
  `true` indicating that error was found.

#### getLocation

    protected org.eclipse.core.runtime.IPath getLocation​(String filename)

If the file designated by filename exists, return the IPath representation of the filename If it does not exist, try cygpath translation

Parameters:
  `filename` - - file name
Returns:
  location (outside of the workspace).